#define INCL_WIN
#define INCL_GPI
#define INCL_DOS
#define INCL_DOSERRORS

#include <OS2.h>
#include <StdLib.h>

#include "..\\..\\Nice-os2\\Shared\\General.h"

#include "..\\..\\Nice-os2\\Shared\\Strings.h"
#include "..\\..\\Nice-os2\\Shared\\Strings\\Strings_data.cpp"
#include "..\\..\\Nice-os2\\Shared\\Strings\\Strings_code.cpp"
#include "..\\..\\Nice-os2\\Shared\\Strings.cpp"

#include "..\\..\\Nice-os2\\Shared\\Files\\Files_code.cpp"
#include "..\\..\\Nice-os2\\Shared\\Files.cpp"

//  ਫ 

INT main( INT argc, CHAR *argv[] )
{
 // ᫨    䠩,   ᬮ - 室.
 if( argc < 2 ) return 0;

 //   䠩  ࠧ ࠢ筨.
 PCHAR File_name = argv[ 1 ]; CHAR Topic[ SIZE_OF_NAME ] = "";

 for( INT Count = 2; Count < argc; Count ++ )
  {
   strcat( Topic, argv[ Count ] );
   if( Count != argc - 1 ) strcat( Topic, " " );
  }

 // ᯮ  䠩.
 BYTE File_is_HLP  = 0; if( strifind( ".inf", File_name ) ) File_is_HLP  = 1;
 BYTE File_is_HTML = 0; if( strifind( ".htm", File_name ) ) File_is_HTML = 1;

 // ᫨   ᯮ - 室.
 if( !File_is_HLP ) if( !File_is_HTML ) return 0;

 // ।塞 ਫ  ⥬.
 HAB Application = WinInitialize( 0 );

 // ᫨  ᤥ  㤠 - 室.
 if( Application == NULLHANDLE )
  {
   //  - 訡.
   WinAlarm( HWND_DESKTOP, WA_ERROR );
   // 室.
   return 0;
  }

 //  । ᮮ饭.
 HMQ Message_queue = WinCreateMsgQueue( Application, 0 );

 // ᫨ । ᮧ  㤠 - 室.
 if( Message_queue == NULLHANDLE )
  {
   //  - 訡.
   WinAlarm( HWND_DESKTOP, WA_ERROR );
   // 室.
   WinTerminate( Application ); return 0;
  }

 //  ࠡ稩 ⠫.
 CHAR Current_directory[ SIZE_OF_PATH ] = "";

 ULONG Current_drive = 0; ULONG Drive_map = 0; ULONG Length = SIZE_OF_PATH - 3;
 DosQueryCurrentDisk( &Current_drive, &Drive_map );
 Current_directory[ 0 ] = (CHAR) Current_drive + 64;
 Current_directory[ 1 ] = ':';
 Current_directory[ 2 ] = '\\';
 DosQueryCurrentDir( 0, &Current_directory[ 3 ], &Length );

 // 室 䠩 ஥.
 CHAR Ini_file_name[ SIZE_OF_PATH ] = "";

 for( Count = 0; Count < 2; Count ++ )
  {
   strcpy( Ini_file_name, Current_directory );

   for( INT Dir_count = 0; Dir_count < 2; Dir_count ++ ) CutNameInPath( Ini_file_name );

   if( Count == 0 ) strcat( Ini_file_name, "\\Enhancer\\Nice-os2.ini" );
   if( Count == 1 ) strcat( Ini_file_name, "\\Nice\\Enhancer\\Nice-os2.ini" );

   if( FileIsExists( Ini_file_name ) ) break;
  }

 // 뢠 䠩 ஥.
 HINI Ini_file = PrfOpenProfile( Application, Ini_file_name ); ULONG Path;

 // ⠥ ᯨ᮪ ਫ.
 CHAR NewView_exe[] = "NewView.exe";
 CHAR NewView_path[ SIZE_OF_PATH ] = "";
 CHAR NewView_file[ SIZE_OF_PATH ] = "";

 if( File_is_HLP )
  {
   Path = SIZE_OF_PATH; PrfQueryProfileData( Ini_file, "Applications", "NewView path", NewView_path, &Path );
   if( NewView_path[ 0 ] != 0 ) { strcpy( NewView_file, NewView_path ); strcat( NewView_file, "\\" ); }
   strcat( NewView_file, NewView_exe );
  }

 CHAR View_exe[] = "View.exe";
 CHAR View_path[] = "";
 CHAR View_file[] = "View.exe";

 CHAR Mozilla_exe[] = "Mozilla.exe";
 CHAR Mozilla_path[ SIZE_OF_PATH ] = "";
 CHAR Mozilla_file[ SIZE_OF_PATH ] = "";

 if( File_is_HTML )
  {
   Path = SIZE_OF_PATH; PrfQueryProfileData( Ini_file, "Applications", "Mozilla path", Mozilla_path, &Path );
   if( Mozilla_path[ 0 ] != 0 ) { strcpy( Mozilla_file, Mozilla_path ); strcat( Mozilla_file, "\\" );  }
   strcat( Mozilla_file, Mozilla_exe );
  }

 CHAR Netscape_4_exe[] = "Netscape.exe";
 CHAR Netscape_4_path[] = "";
 CHAR Netscape_4_file[] = "Netscape.exe";

 CHAR Links_exe[] = "Links.exe";
 CHAR Links_path[ SIZE_OF_PATH ] = "";
 CHAR Links_file[ SIZE_OF_PATH ] = "";

 if( File_is_HTML )
  {
   Path = SIZE_OF_PATH; PrfQueryProfileData( Ini_file, "Applications", "Links path", Links_path, &Path );
   if( Links_path[ 0 ] != 0 ) { strcpy( Links_file, Links_path ); strcat( Links_file, "\\" );  }
   strcat( Links_file, Links_exe );
  }

 // 뢠 䠩 ஥.
 PrfCloseProfile( Ini_file );

 // 뢠   ਫ.
 INT Quantity = 3;

 for( Count = 0; Count < Quantity; Count ++  )
  {
   PCHAR Exe_name = NULL; PCHAR Path = NULL; PCHAR Exe_file = NULL;

   if( File_is_HLP )
    {
     if( Count == 0 ) { Exe_name = NewView_exe; Path = NewView_path; Exe_file = NewView_file; }
     if( Count == 1 ) { Exe_name = View_exe;    Path = View_path;    Exe_file = View_file;    }
    }

   if( File_is_HTML )
    {
     if( Count == 0 ) { Exe_name = Mozilla_exe;    Path = Mozilla_path;    Exe_file = Mozilla_file;    }
     if( Count == 1 ) { Exe_name = Netscape_4_exe; Path = Netscape_4_path; Exe_file = Netscape_4_file; }
     if( Count == 2 ) { Exe_name = Links_exe;      Path = Links_path;      Exe_file = Links_file;      }
    }

   if( Exe_name != NULL )
    {
     BYTE Arguments[ SIZE_OF_NAME ] = "";

     if( Exe_file == Links_file )
      {
       CHAR Jpeg_dll[ SIZE_OF_PATH ] = ""; strcpy( Jpeg_dll, Links_file );
       INT Length = strlen( Jpeg_dll ); INT Length_of_name = strlen( "Links.exe" );
       strcpy( &Jpeg_dll[ Length - Length_of_name ], "Jpeg.dll" );

       if( !FileIsExists( Jpeg_dll ) ) continue;

       strcpy( Arguments, "-g" );
      }

     CHAR Parameters[ SIZE_OF_PATH ] = "";
     strcpy( Parameters, Exe_name ); strcat( Parameters, "|" );
     if( Arguments[ 0 ] != 0 ) { strcat( Parameters, Arguments ); strcat( Parameters, " " ); }
     strcat( Parameters, File_name );
     if( Topic[ 0 ] != 0 ) { strcat( Parameters, " " ); strcat( Parameters, Topic ); }
     strchg( Parameters, '|', 0x00 );

     if( Path[ 0 ] != 0 ) { DosSetDefaultDisk( DriveNumberFromPath( Path ) ); DosSetCurrentDir( Path ); }
     CHAR Error_string[ 1 ] = ""; RESULTCODES Return_codes;
     DosResetBuffer( -1 ); APIRET Result = DosExecPgm( Error_string, sizeof( Error_string ), EXEC_ASYNC, Parameters, NULL, &Return_codes, Exe_file );
     if( Path[ 0 ] != 0 ) { DosSetDefaultDisk( DriveNumberFromPath( Current_directory ) ); DosSetCurrentDir( Current_directory ); }

     if( Result == NO_ERROR ) break;
    }
  }

 // 뢠 । ᮮ饭.
 WinDestroyMsgQueue( Message_queue );

 // 室.
 WinTerminate( Application ); return 0;
}
